#include "GCMotion.h"

using namespace System;
using namespace System::Windows::Forms;

/*****************************************************************
* Function Name : 指令返回值
* Description   : 返回错误值 rtn
* Date			: 2022年8月3日
* Auther		: LWH
******************************************************************/
short gc_rtn_error(short rtn)
{
	if (rtn != RTN_CMD_SUCCESS) {
		return rtn;		// 指令执行错误
	}
}

/*****************************************************************
* Function Name : 位置比较：线性位置比较例程（等间距输出）
* Description   : 略
* Date			: 2022年8月3日
* Auther		: LWH
******************************************************************/
short gc_example_comp_linear2(void)
{
	short rtn;					// 指令返回值
	short devNum;				// 设备序号，从0开始
	short axisNum;				// 轴号，从0开始
	HAND devHandle;				// 设备句柄
	HAND axisHandle;			// 轴句柄
	HAND crdHandle;				// 坐标系句柄
	rtn = NMC_DevOpen(devNum, &devHandle);				//打开控制器
	gc_rtn_error(rtn);
	rtn = NMC_MtOpen(devHandle, axisNum, &axisHandle);	//打开轴,并获得轴句柄
	gc_rtn_error(rtn);
	rtn = NMC_MtSetSvOn(axisHandle);					//打开轴使能(根据实际情况使用)
	gc_rtn_error(rtn);

	long startPos[2] = { 0,0 };
	// 设置线性位置比较参数：一维，轴掩码0x1（第一个轴），位置源为规划位置，按等间距输出，脉宽为0.0009秒
	rtn = NMC_LinearCompSetParam(devHandle, 1, 0x3, 1, 1, 0.0009, 0);
	gc_rtn_error(rtn);
	// 间隔1000个脉冲，输出5个
	rtn = NMC_LinearCompInterval(devHandle, startPos, 1000, 5, 0);
	gc_rtn_error(rtn);
	// 启动线性位置比较输出
	rtn = NMC_LinearCompOnOff(devHandle, 1, 0);
	gc_rtn_error(rtn);
	// 启动第一个轴的运动后（启动第二轴或者坐标系先这两个轴的插补也是一样），gate信号有信号输出
	NMC_MtOpen(devHandle, 0, &axisHandle);
	rtn = NMC_MtMovePtpAbs(axisHandle, 1, 1, 0, 0, 5, 0, 100000);
	gc_rtn_error(rtn);
	return rtn;
}